## Slackware install script for tomcat
##   20050728 Stefano Stabellini
#

config() {
        NEW="$1"
        OLD="`dirname $NEW`/`basename $NEW .new`"
        # If there's no config file by that name, mv it over:
        if [ ! -r $OLD ]; then
                mv $NEW $OLD
        elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then
                # toss the redundant copy
                rm $NEW
        fi
        # Otherwise, we leave the .new copy for the admin to consider...
}

config etc/rc.d/rc.tomcat.new
config etc/tomcat/Catalina/localhost/host-manager.xml.new
config etc/tomcat/Catalina/localhost/manager.xml.new
config etc/tomcat/catalina.policy.new
config etc/tomcat/catalina.properties.new
config etc/tomcat/context.xml.new
#config etc/tomcat/jk2.manifest.new
#config etc/tomcat/jkconf.ant.xml.new
#config etc/tomcat/jkconfig.manifest.new
#config etc/tomcat/jk2.properties.new
config etc/tomcat/server-minimal.xml.new
config etc/tomcat/server.xml.new
#config etc/tomcat/shm.manifest.new
config etc/tomcat/tomcat-users.xml.new
#config etc/tomcat/tomcat-jk2.manifest.new
#config etc/tomcat/uriworkermap.properties.new
config etc/tomcat/web.xml.new
#config etc/tomcat/workers.properties.new
#config etc/tomcat/workers.properties.minimal.new
#config etc/tomcat/workers2.properties.new
#config etc/tomcat/workers2.properties.minimal.new
config etc/tomcat/logging.properties.new

if ! grep -q tomcat /etc/group; then
        groupadd tomcat
fi
if ! grep -q tomcat /etc/passwd; then
        useradd -g tomcat -d /usr/share/tomcat -c "JSP Container" -s /bin/sh tomcat
fi

chown -R tomcat.tomcat /etc/tomcat
chown -R tomcat.tomcat /var/lib/tomcat
chown -R tomcat.tomcat /var/cache/tomcat
chown -R tomcat.tomcat /var/tmp/tomcat
chown -R tomcat.tomcat /var/log/tomcat
chown -R tomcat.tomcat /usr/share/tomcat
chmod +x /etc/profile.d/catalina.*
chmod +x /usr/bin/tomcat
( cd usr/share/java ; rm -rf catalina-ant.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina-ant.jar catalina-ant.jar )
( cd usr/share/java ; rm -rf tomcat-coyote.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-coyote.jar tomcat-coyote.jar )
( cd usr/share/java ; rm -rf catalina-optional.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina-optional.jar catalina-optional.jar )
( cd usr/share/java ; rm -rf naming-factory-dbcp.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/naming-factory-dbcp.jar naming-factory-dbcp.jar )
( cd usr/share/java ; rm -rf tomcat-util.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-util.jar tomcat-util.jar )
( cd usr/share/java ; rm -rf jasper-compiler.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/jasper-compiler.jar jasper-compiler.jar )
( cd usr/share/java ; rm -rf servlet-api.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/servlet-api.jar servlet-api.jar )
( cd usr/share/java ; rm -rf catalina-storeconfig.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina-storeconfig.jar catalina-storeconfig.jar )
( cd usr/share/java ; rm -rf commons-el.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/commons-el.jar commons-el.jar )
( cd usr/share/java ; rm -rf jasper-compiler-jdt.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/jasper-compiler-jdt.jar jasper-compiler-jdt.jar )
( cd usr/share/java ; rm -rf naming-factory.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/naming-factory.jar naming-factory.jar )
( cd usr/share/java ; rm -rf tomcat-http.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-http.jar tomcat-http.jar )
( cd usr/share/java ; rm -rf catalina-ant-jmx.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina-ant-jmx.jar catalina-ant-jmx.jar )
( cd usr/share/java ; rm -rf jasper-runtime.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/jasper-runtime.jar jasper-runtime.jar )
( cd usr/share/java ; rm -rf jsp-api.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/jsp-api.jar jsp-api.jar )
( cd usr/share/java ; rm -rf servlets-invoker.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/servlets-invoker.jar servlets-invoker.jar )
( cd usr/share/java ; rm -rf catalina.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina.jar catalina.jar )
( cd usr/share/java ; rm -rf naming-resources.jar )
( cd usr/share/java ; ln -sf ../tomcat/common/lib/naming-resources.jar naming-resources.jar )
( cd usr/share/java ; rm -rf catalina-cluster.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/catalina-cluster.jar catalina-cluster.jar )
( cd usr/share/java ; rm -rf servlets-default.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/servlets-default.jar servlets-default.jar )
( cd usr/share/java ; rm -rf tomcat-ajp.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-ajp.jar tomcat-ajp.jar )
( cd usr/share/java ; rm -rf commons-modeler.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/commons-modeler.jar commons-modeler.jar )
( cd usr/share/java ; rm -rf tomcat-apr.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-apr.jar tomcat-apr.jar )
( cd usr/share/java ; rm -rf servlets-webdav.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/servlets-webdav.jar servlets-webdav.jar )
( cd usr/share/java ; rm -rf tomcat-jkstatus-ant.jar )
( cd usr/share/java ; ln -sf ../tomcat/server/lib/tomcat-jkstatus-ant.jar tomcat-jkstatus-ant.jar )
( cd usr/share/tomcat ; rm -rf conf )
( cd usr/share/tomcat ; ln -sf ../../../etc/tomcat conf )
( cd usr/share/tomcat ; rm -rf logs )
( cd usr/share/tomcat ; ln -sf ../../../var/log/tomcat logs )
( cd usr/share/tomcat ; rm -rf temp )
( cd usr/share/tomcat ; ln -sf ../../../var/tmp/tomcat temp )
( cd usr/share/tomcat ; rm -rf work )
( cd usr/share/tomcat ; ln -sf ../../../var/cache/tomcat work )
( cd usr/share/tomcat ; rm -rf common )
( cd usr/share/tomcat ; ln -sf ../../../var/lib/tomcat/common common )
( cd usr/share/tomcat ; rm -rf server )
( cd usr/share/tomcat ; ln -sf ../../../var/lib/tomcat/server server )
( cd usr/share/tomcat ; rm -rf shared )
( cd usr/share/tomcat ; ln -sf ../../../var/lib/tomcat/shared shared )
( cd usr/share/tomcat ; rm -rf webapps )
( cd usr/share/tomcat ; ln -sf ../../../var/lib/tomcat/webapps webapps )
